<?xml version="1.0" encoding="UTF-8"?>
<!--
 | Copyright IBM Corporation, 2002
 | This file is part of the DITA package on IBM's developerWorks site.
 | See license.txt for disclaimers.
 |
 | The Darwin Information Typing Architecture (DITA) was orginated by
 | IBM's XML Workgroup and ID Workbench tools team.
 |
 | File: concept.mod
 |
 | Release history (vrm):
 |   1.0.0 Release 1.2 - Initial XML Schema release on IBM's developerWorks, June 2003
 *-->
<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified" attributeFormDefault="unqualified">
  
  
  <!--Embed concept to get specific elements -->
  <xs:element name="concept" type="concept.class" substitutionGroup="topic"/>
  <xs:element name="conbody" abstract="true" substitutionGroup="body"/>
  
  <xs:group name="concept-info-types">
      <xs:choice>
        <xs:element name="concept" type="concept.class"/>
      </xs:choice>
    </xs:group>
    
  <!-- Base type: topic.class -->
  <xs:complexType name="concept.class">
    <xs:complexContent>
      <xs:restriction base="topic.class">
        <xs:sequence>
          <xs:element ref="title"/>
          <xs:element ref="titlealts" minOccurs="0"/>
          <xs:element ref="shortdesc" minOccurs="0"/>
          <xs:element ref="prolog" minOccurs="0"/>
          <xs:element name="conbody" type="conbody.class"/>
          <xs:element ref="related-links" minOccurs="0"/>
          <xs:group ref="concept-info-types" minOccurs="0" maxOccurs="unbounded"/>
        </xs:sequence>
        <xs:attribute name="id" type="xs:ID" use="required"/>
        <xs:attribute name="conref" type="xs:string"/>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/topic concept/concept"/>
        <xs:attribute name="domains" type="xs:string" default="(topic ui-d) (topic hi-d) (topic sw-d) (topic pr-d)"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  
  <!-- Base type: body.class -->
  <xs:complexType name="conbody.class">
    <xs:complexContent>
      <xs:restriction base="body.class">
        <xs:sequence>
          <xs:group ref="body.cnt" minOccurs="0" maxOccurs="unbounded"/>
          <xs:choice minOccurs="0" maxOccurs="unbounded">
            <xs:element ref="section"/>
            <xs:element ref="example"/>
          </xs:choice>
        </xs:sequence>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/body concept/conbody"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
</xs:schema>
