<?xml version="1.0" encoding="UTF-8"?>
<!--
 | (C) Copyright IBM Corporation 2001, 2002, 2003. All Rights Reserved.
 | This file is part of the DITA package on IBM's developerWorks site.
 | See license.txt for disclaimers.
 |
 | The Darwin Information Typing Architecture (DITA) was orginated by
 | IBM's XML Workgroup and ID Workbench tools team.
 |
 | File: programming-domain.mod
 |
 | Release history (vrm):
 |   1.0.0 Release 1.2 - Initial XML Schema release on IBM's developerWorks, June 2003
 *-->
<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified" attributeFormDefault="unqualified">
  <!-- ==================== Import Section ======================= -->
  <xs:import namespace="http://www.w3.org/XML/1998/namespace" schemaLocation="xml.xsd"/>

  <xs:attributeGroup name="univ-atts-no-importance">
    <xs:attributeGroup ref="id-atts"/>
    <xs:attribute name="platform" type="xs:string"/>
    <xs:attribute name="product" type="xs:string"/>
    <xs:attribute name="audience" type="xs:string"/>
    <xs:attribute name="otherprops" type="xs:string"/>
    <xs:attribute name="rev" type="xs:string"/>
    <xs:attribute name="translate" type="yesno-att.class"/>
    <xs:attribute ref="xml:lang"/>
  </xs:attributeGroup>

  <xs:attributeGroup name="univ-atts-importance-nodefault">
    <xs:attributeGroup ref="id-atts"/>
    <xs:attribute name="platform" type="xs:string"/>
    <xs:attribute name="product" type="xs:string"/>
    <xs:attribute name="audience" type="xs:string"/>
    <xs:attribute name="otherprops" type="xs:string"/>
    <xs:attribute name="rev" type="xs:string"/>
    <xs:attribute name="importance" type="importance-att-nodefault.class"/>
    <xs:attribute name="translate" type="yesno-att.class"/>
    <xs:attribute ref="xml:lang"/>
  </xs:attributeGroup>

  <xs:simpleType name="importance-att-progdom.class">
    <xs:restriction base="importance-atts.class">
      <xs:enumeration value="optional"/>
      <xs:enumeration value="required"/>
      <xs:enumeration value="default"/>
    </xs:restriction>
  </xs:simpleType>

  <xs:simpleType name="importance-att-nodefault.class">
    <xs:restriction base="importance-atts.class">
      <xs:enumeration value="optional"/>
      <xs:enumeration value="required"/>
    </xs:restriction>
  </xs:simpleType>

  <xs:element name="codeph" type="codeph.class" substitutionGroup="ph"/>
  <xs:complexType name="codeph.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="ph.class">
        <xs:attribute name="outputclass" type="xs:string"/>
	<xs:attributeGroup ref="global-atts"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attribute ref="class" default="+ topic/ph pr-d/codeph "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <xs:element name="codeblock" type="codeblock.class" substitutionGroup="pre"/>
  <xs:complexType name="codeblock.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="pre.class">
        <xs:choice minOccurs="0" maxOccurs="unbounded">
          <xs:group ref="pre.cnt"/>
        </xs:choice>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attribute name="spectitle" type="xs:string"/>
        <xs:attributeGroup ref="display-atts"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attribute ref="xml:space"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="+ topic/pre pr-d/codeblock"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <xs:element name="option" type="option.class" substitutionGroup="keyword"/>
  <xs:complexType name="option.class">
    <xs:simpleContent>
      <xs:restriction base="keyword.class">
        <xs:attribute name="keyref" type="xs:NMTOKEN"/>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="global-atts"/>
	<xs:attributeGroup ref="univ-atts"/>
        <xs:attribute ref="class" default="+ topic/keyword pr-d/option"/>
      </xs:restriction>
    </xs:simpleContent>
  </xs:complexType>

  <xs:element name="var" type="var.class" substitutionGroup="ph"/>
  <xs:complexType name="var.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="ph.class">
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attributeGroup ref="univ-atts-no-importance"/>
        <xs:attribute ref="class" default="+ topic/ph pr-d/var"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <xs:element name="parmname" type="parmname.class" substitutionGroup="keyword"/>
  <xs:complexType name="parmname.class">
    <xs:simpleContent>
      <xs:restriction base="keyword.class">
        <xs:attribute name="keyref" type="xs:NMTOKEN"/>
        <xs:attribute name="outputclass" type="xs:string"/>
	<xs:attributeGroup ref="global-atts"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attribute ref="class" default="+ topic/keyword  pr-d/parmname"/>
      </xs:restriction>
    </xs:simpleContent>
  </xs:complexType>

  <xs:element name="synph" type="synph.class" substitutionGroup="ph"/>
  <xs:complexType name="synph.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="ph.class">
        <xs:choice minOccurs="0" maxOccurs="unbounded">
          <!-- ph -->
          <xs:element ref="codeph"/>
          <xs:element ref="var"/>
          <xs:element ref="oper"/>
          <xs:element ref="delim"/>
          <xs:element ref="sep"/>
          <xs:element ref="synph"/>
          <!-- keyword -->
          <xs:element ref="option"/>
          <xs:element ref="parmname"/>
          <xs:element ref="kwd"/>
        </xs:choice>
        <xs:attribute name="outputclass" type="xs:string"/>
	<xs:attributeGroup ref="global-atts"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attribute ref="class" default="+ topic/ph pr-d/synph"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <xs:element name="oper" type="oper.class" substitutionGroup="ph"/>
  <xs:complexType name="oper.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="ph.class">
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="univ-atts-no-importance"/>
        <xs:attribute name="importance" type="importance-att-progdom.class"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="+ topic/ph pr-d/oper"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <xs:element name="delim" type="delim.class" substitutionGroup="ph"/>
  <xs:complexType name="delim.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="ph.class">
        <xs:attribute name="outputclass" type="xs:string"/>
	<xs:attributeGroup ref="global-atts"/>
        <xs:attributeGroup ref="univ-atts-no-importance"/>
	<xs:attribute name="importance" type="importance-att-nodefault.class"/>
        <xs:attribute ref="class" default="+ topic/ph pr-d/delim"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <xs:element name="sep" type="sep.class" substitutionGroup="ph"/>
  <xs:complexType name="sep.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="ph.class">
        <xs:attribute name="outputclass" type="xs:string"/>
	<xs:attributeGroup ref="global-atts"/>
        <xs:attributeGroup ref="univ-atts-no-importance"/>
	<xs:attribute name="importance" type="importance-att-nodefault.class"/>
        <xs:attribute ref="class" default="+ topic/ph pr-d/sep"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <xs:element name="apiname" type="apiname.class" substitutionGroup="keyword"/>
  <xs:complexType name="apiname.class">
    <xs:simpleContent>
      <xs:restriction base="keyword.class">
        <xs:attribute name="keyref" type="xs:NMTOKEN"/>
        <xs:attribute name="outputclass" type="xs:string"/>
	<xs:attributeGroup ref="global-atts"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attribute ref="class" default="+ topic/keyword  pr-d/apiname"/>
      </xs:restriction>
    </xs:simpleContent>
  </xs:complexType>

  <xs:element name="parml" type="parml.class" substitutionGroup="dl"/>
  <xs:complexType name="parml.class">
    <xs:complexContent>
      <xs:restriction base="dl.class">
        <xs:sequence>
          <xs:element ref="plentry"/>
        </xs:sequence>
        <xs:attribute name="spectitle" type="xs:string"/>
        <xs:attribute name="outputclass" type="xs:string"/>
	<xs:attributeGroup ref="global-atts"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attribute name="compact" type="yesno-att.class" default="yes"/>
        <xs:attribute ref="class" default="+ topic/dl pr-d/parml"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <xs:element name="plentry" type="plentry.class" substitutionGroup="dlentry"/>
  <xs:complexType name="plentry.class">
    <xs:choice>
      <xs:element ref="pt" minOccurs="0"/>
      <xs:element ref="pd" minOccurs="0"/>
    </xs:choice>
    <xs:attribute name="outputclass" type="xs:string"/>
    <xs:attributeGroup ref="global-atts"/>
    <xs:attributeGroup ref="univ-atts"/>
    <xs:attribute ref="class" default="+ topic/dlentry pr-d/plentry"/>
  </xs:complexType>

  <xs:element name="pt" type="pt.class" substitutionGroup="dt"/>
  <xs:complexType name="pt.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="dt.class">
        <xs:choice minOccurs="0" maxOccurs="unbounded">
          <xs:group ref="term.cnt"/>
        </xs:choice>
        <xs:attribute name="keyref" type="xs:NMTOKEN"/>
        <xs:attribute name="outputclass" type="xs:string"/>
	<xs:attributeGroup ref="global-atts"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attribute ref="class" default="+ topic/dt pr-d/pt"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <xs:element name="pd" type="pd.class" substitutionGroup="dd"/>
  <xs:complexType name="pd.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="dd.class">
        <xs:choice minOccurs="0" maxOccurs="unbounded">
          <xs:group ref="defn.cnt"/>
        </xs:choice>
        <xs:attribute name="outputclass" type="xs:string"/>
	<xs:attributeGroup ref="global-atts"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attribute ref="class" default="+ topic/dd pr-d/pd"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <!-- Base form: Syntax Diagram -->
  <xs:element name="syntaxdiagram" type="syntaxdiagram.class" substitutionGroup="fig"/>
  <xs:complexType name="syntaxdiagram.class">
    <xs:complexContent>
      <xs:restriction base="fig.class">
        <xs:sequence>
          <xs:element ref="title" minOccurs="0" maxOccurs="1"/>
          <xs:choice minOccurs="0" maxOccurs="unbounded">
              <xs:group ref="syntaxdiagram.grp"/>
              <xs:element ref="fragment"/>
              <xs:element ref="synblk"/>
          </xs:choice>
        </xs:sequence>
        <xs:attribute name="outputclass" type="xs:string"/>
	    <xs:attributeGroup ref="global-atts"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attributeGroup ref="display-atts"/>
        <xs:attribute ref="class" default="+ topic/fig pr-d/syntaxdiagram"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <xs:group name="syntaxdiagram.grp">
    <xs:choice>
      <xs:element ref="groupseq"/>
      <xs:element ref="groupchoice"/>
      <xs:element ref="groupcomp"/>
      <xs:element ref="fragref"/>
      <xs:element ref="synnote"/>
      <xs:element ref="synnoteref"/>
    </xs:choice>
  </xs:group>

  <xs:group name="syntaxdiagramprog.grp">
    <xs:choice>
      <xs:element ref="kwd"/>
      <xs:element ref="var"/>
      <xs:element ref="delim"/>
      <xs:element ref="oper"/>
      <xs:element ref="sep"/>
    </xs:choice>
  </xs:group>

  <xs:element name="synblk" type="synblk.class" substitutionGroup="figgroup"/>
  <xs:complexType name="synblk.class">
    <xs:complexContent>
      <xs:restriction base="figgroup.class">
        <xs:sequence>
          <xs:element ref="title" minOccurs="0"/>
          <xs:choice minOccurs="0" maxOccurs="unbounded">
            <xs:group ref="syntaxdiagram.grp"/>
            <xs:element ref="fragment"/>
          </xs:choice>
        </xs:sequence>
        <xs:attribute name="outputclass" type="xs:string"/>
	<xs:attributeGroup ref="global-atts"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attribute ref="class" default="+ topic/figgroup pr-d/synblk"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <xs:element name="groupseq" type="groupseq.class" substitutionGroup="figgroup"/>
  <xs:complexType name="groupseq.class">
    <xs:complexContent>
      <xs:restriction base="figgroup.class">
        <xs:sequence>
          <xs:element ref="title" minOccurs="0"/>
          <xs:choice minOccurs="0" maxOccurs="unbounded">
            <xs:group ref="syntaxdiagram.grp"/>
            <xs:group ref="syntaxdiagramprog.grp"/>
          </xs:choice>
        </xs:sequence>
        <xs:attribute name="outputclass" type="xs:string"/>
	<xs:attributeGroup ref="global-atts"/>
        <xs:attributeGroup ref="univ-atts-no-importance"/>
	<xs:attribute name="importance" type="importance-att-progdom.class"/>
        <xs:attribute ref="class" default="+ topic/figgroup pr-d/groupseq"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <xs:element name="groupchoice" type="groupchoice.class" substitutionGroup="figgroup"/>
  <xs:complexType name="groupchoice.class">
    <xs:complexContent>
      <xs:restriction base="figgroup.class">
        <xs:sequence>
          <xs:element ref="title" minOccurs="0"/>
          <xs:choice minOccurs="0" maxOccurs="unbounded">
            <xs:group ref="syntaxdiagram.grp"/>
            <xs:group ref="syntaxdiagramprog.grp"/>
          </xs:choice>
        </xs:sequence>
        <xs:attribute name="outputclass" type="xs:string"/>
	<xs:attributeGroup ref="global-atts"/>
        <xs:attributeGroup ref="univ-atts-no-importance"/>
	<xs:attribute name="importance" type="importance-att-progdom.class"/>
        <xs:attribute ref="class" default="+ topic/figgroup pr-d/groupchoice"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <xs:element name="groupcomp" type="groupcomp.class" substitutionGroup="figgroup"/>
  <xs:complexType name="groupcomp.class">
    <xs:complexContent>
      <xs:restriction base="figgroup.class">
        <xs:sequence>
          <xs:element ref="title" minOccurs="0"/>
          <xs:choice minOccurs="0" maxOccurs="unbounded">
            <xs:group ref="syntaxdiagram.grp"/>
            <xs:group ref="syntaxdiagramprog.grp"/>
          </xs:choice>
        </xs:sequence>
        <xs:attribute name="outputclass" type="xs:string"/>
	<xs:attributeGroup ref="global-atts"/>
        <xs:attributeGroup ref="univ-atts-no-importance"/>
	<xs:attribute name="importance" type="importance-att-progdom.class"/>
        <xs:attribute ref="class" default="+ topic/figgroup pr-d/groupcomp"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <xs:element name="fragment" type="fragment.class" substitutionGroup="figgroup"/>
  <xs:complexType name="fragment.class">
    <xs:complexContent>
      <xs:restriction base="figgroup.class">
        <xs:sequence>
          <xs:element ref="title" minOccurs="0"/>
          <xs:choice minOccurs="0" maxOccurs="unbounded">
            <xs:group ref="syntaxdiagram.grp"/>
          </xs:choice>
        </xs:sequence>
        <xs:attribute name="outputclass" type="xs:string"/>
	<xs:attributeGroup ref="global-atts"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attribute ref="class" default="+ topic/figgroup pr-d/fragment"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <xs:element name="fragref" type="fragref.class" substitutionGroup="xref"/>
  <xs:complexType name="fragref.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="xref.class">
        <xs:choice minOccurs="0" maxOccurs="unbounded">
          <xs:group ref="xrefph.cnt"/>
        </xs:choice>
        <xs:attribute name="href" type="xs:string" use="required"/>
        <xs:attribute name="outputclass" type="xs:string"/>
	<xs:attributeGroup ref="global-atts"/>
        <xs:attributeGroup ref="univ-atts-no-importance"/>
	<xs:attribute name="importance" type="importance-att-progdom.class"/>
        <xs:attribute ref="class" default="+ topic/xref pr-d/fragref"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <xs:element name="synnote" type="synnote.class" substitutionGroup="fn"/>
  <xs:complexType name="synnote.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="fn.class">
        <xs:choice minOccurs="0" maxOccurs="unbounded">
          <xs:group ref="basic.ph"/>
        </xs:choice>
        <xs:attribute name="callout" type="xs:string"/>
        <xs:attribute name="outputclass" type="xs:string"/>
	<xs:attributeGroup ref="global-atts"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attribute ref="class" default="+ topic/fn pr-d/synnote"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <xs:element name="synnoteref" type="synnoteref.class" substitutionGroup="xref"/>
  <xs:complexType name="synnoteref.class">
    <xs:complexContent>
      <xs:restriction base="xref.class">
        <xs:attribute name="href" type="xs:string" use="required"/>
        <xs:attribute name="outputclass" type="xs:string"/>
	<xs:attributeGroup ref="global-atts"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attribute ref="class" default="+ topic/xref pr-d/synnoteref"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <xs:element name="repsep" type="repsep.class" substitutionGroup="ph"/>
  <xs:complexType name="repsep.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="ph.class">
        <xs:attribute name="outputclass" type="xs:string"/>
         <xs:attributeGroup ref="global-atts"/>
        <xs:attributeGroup ref="univ-atts-no-importance"/>
         <xs:attribute name="importance" type="importance-att-progdom.class"/>
        <xs:attribute ref="class" default="+ topic/ph pr-d/repsep"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <xs:element name="kwd" type="kwd.class" substitutionGroup="keyword"/>
  <xs:complexType name="kwd.class">
    <xs:simpleContent>
      <xs:restriction base="keyword.class">
        <xs:attribute name="keyref" type="xs:NMTOKEN"/>
        <xs:attribute name="outputclass" type="xs:string"/>
	<xs:attributeGroup ref="global-atts"/>
        <xs:attributeGroup ref="univ-atts-no-importance"/>
	<xs:attribute name="importance" type="importance-att-progdom.class"/>
        <xs:attribute ref="class" default="+ topic/keyword pr-d/kwd"/>
      </xs:restriction>
    </xs:simpleContent>
  </xs:complexType>
</xs:schema>
