<?xml version="1.0" encoding="UTF-8"?>
<!--
 | (C) Copyright IBM Corporation 2001, 2002, 2003. All Rights Reserved.
 | This file is part of the DITA package on IBM's developerWorks site.
 | See license.txt for disclaimers.
 |
 | The Darwin Information Typing Architecture (DITA) was orginated by
 | IBM's XML Workgroup and ID Workbench tools team.
 |
 | File: task.mod
 |
 | Release history (vrm):
 |   1.0.0 Release 1.2 - Initial XML Schema release on IBM's developerWorks, June 2003
 *-->
<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified" attributeFormDefault="unqualified">
  <!-- ==================== Import Section ======================= -->
  <xs:import namespace="http://www.w3.org/XML/1998/namespace" schemaLocation="xml.xsd"/>

  <!-- Base type: univ-atts -->
  <xs:attributeGroup name="univ-atts-importance-task">
    <xs:attributeGroup ref="id-atts"/>
    <xs:attribute name="platform" type="xs:string"/>
    <xs:attribute name="product" type="xs:string"/>
    <xs:attribute name="audience" type="xs:string"/>
    <xs:attribute name="otherprops" type="xs:string"/>
    <xs:attribute name="rev" type="xs:string"/>
    <xs:attribute name="importance" type="importance-att-nodefault-task.class"/>
    <xs:attribute name="translate" type="yesno-att.class"/>
    <xs:attribute ref="xml:lang"/>
  </xs:attributeGroup>
  
  <!-- Base type: importance-atts.class -->
  <xs:simpleType name="importance-att-nodefault-task.class">
    <xs:restriction base="importance-atts.class">
      <xs:enumeration value="optional"/>
      <xs:enumeration value="required"/>
    </xs:restriction>
  </xs:simpleType>

  <!-- Element declarations for task.mod -->
  <xs:element name="task" type="task.class" substitutionGroup="topic"/>
  <xs:element name="taskbody" abstract="true" substitutionGroup="body"/>
  <xs:element name="prereq" abstract="true" substitutionGroup="section"/>
  <xs:element name="context" abstract="true" substitutionGroup="section"/>
  <xs:element name="result" abstract="true" substitutionGroup="section"/>
  <xs:element name="postreq" abstract="true" substitutionGroup="section"/>
  <xs:element name="choice" abstract="true" substitutionGroup="li"/>
  <xs:element name="step" abstract="true" substitutionGroup="li"/>
  <xs:element name="substep" abstract="true" substitutionGroup="li"/>
  <xs:element name="choices" abstract="true" substitutionGroup="ul"/>
  <xs:element name="steps" abstract="true" substitutionGroup="ol"/>
  <xs:element name="substeps" abstract="true" substitutionGroup="ol"/>
  <xs:element name="cmd" abstract="true" substitutionGroup="ph"/>
  <xs:element name="info" abstract="true" substitutionGroup="itemgroup"/>
  <xs:element name="tutorialinfo" abstract="true" substitutionGroup="itemgroup"/>
  <xs:element name="stepxmp" abstract="true" substitutionGroup="itemgroup"/>
  <xs:element name="stepresult" abstract="true" substitutionGroup="itemgroup"/>
  <xs:element name="choicetable" abstract="true" substitutionGroup="simpletable"/>
  <xs:element name="chhead" abstract="true" substitutionGroup="sthead"/>
  <xs:element name="chrow" abstract="true" substitutionGroup="strow"/>
  <xs:element name="choptionhd" abstract="true" substitutionGroup="stentry"/>
  <xs:element name="chdeschd" abstract="true" substitutionGroup="stentry"/>
  <xs:element name="choption" abstract="true" substitutionGroup="stentry"/>
  <xs:element name="chdesc" abstract="true" substitutionGroup="stentry"/>
  <!-- Element declarations for task.mod -->

  	<xs:group name="task-info-types">
        <xs:choice>
        	<xs:element name="task" type="task.class" />
        </xs:choice>
   </xs:group>

  <!-- Base type: topic.class -->
  <xs:complexType name="task.class">
    <xs:complexContent>
      <xs:restriction base="topic.class">
        <xs:sequence>
          <xs:element ref="title"/>
          <xs:element ref="titlealts" minOccurs="0"/>
          <xs:element ref="shortdesc" minOccurs="0"/>
          <xs:element ref="prolog" minOccurs="0"/>
          <xs:element name="taskbody" type="taskbody.class"/>
          <xs:element ref="related-links" minOccurs="0"/>
          <xs:group ref="task-info-types" minOccurs="0" maxOccurs="unbounded"/>
        </xs:sequence>
        <xs:attribute name="id" type="xs:ID" use="required"/>
        <xs:attribute name="conref" type="xs:string"/>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/topic task/task "/>
        <xs:attribute name="domains" type="xs:string" default="(topic ui-d) (topic hi-d) (topic sw-d) (topic pr-d)"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <!-- Base type: body.class -->
  <xs:complexType name="taskbody.class">
    <xs:complexContent>
      <xs:restriction base="body.class">
        <xs:sequence>
          <xs:element name="prereq" type="prereq.class" minOccurs="0"/>
          <xs:element name="context" type="context.class" minOccurs="0"/>
          <xs:element name="steps" type="steps.class" minOccurs="0"/>
          <xs:element name="result" type="result.class" minOccurs="0"/>
          <xs:element ref="example" minOccurs="0"/>
          <xs:element name="postreq" type="postreq.class" minOccurs="0"/>
        </xs:sequence>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/body  task/taskbody "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>

  <!-- Base type: section.class -->
  <xs:complexType name="prereq.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="section.class">
        <xs:choice minOccurs="0" maxOccurs="unbounded">
          <xs:group ref="section.notitle.cnt"/>
        </xs:choice>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/section  task/prereq "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  <!-- Base type: section.class -->
  <xs:complexType name="context.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="section.class">
        <xs:choice minOccurs="0" maxOccurs="unbounded">
          <xs:group ref="section.notitle.cnt"/>
        </xs:choice>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/section  task/context "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  <!-- Base type: ol.class -->
  <xs:complexType name="steps.class">
    <xs:complexContent>
      <xs:restriction base="ol.class">
        <xs:choice>
          <xs:element name="step" type="step.class" maxOccurs="unbounded"/>
        </xs:choice>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/ol     task/steps "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  <!-- Base type: li.class -->
  <xs:complexType name="step.class">
    <xs:complexContent>
      <xs:restriction base="li.class">
        <xs:sequence>
          <xs:element name="cmd" type="cmd.class"/>
          <xs:choice minOccurs="0" maxOccurs="unbounded">
            <xs:element name="info" type="info.class"/>
            <xs:element name="substeps" type="substeps.class"/>
            <xs:element name="tutorialinfo" type="tutorialinfo.class"/>
            <xs:element name="stepxmp" type="stepxmp.class"/>
            <xs:element name="choicetable" type="choicetable.class"/>
            <xs:element name="choices" type="choices.class"/>
          </xs:choice>
          <xs:element name="stepresult" type="stepresult.class" minOccurs="0"/>
        </xs:sequence>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="univ-atts-importance-task"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/li     task/step "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  <!-- Base type: ph.class -->
  <xs:complexType name="cmd.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="ph.class">
        <xs:choice minOccurs="0" maxOccurs="unbounded">
          <xs:group ref="ph.cnt"/>
        </xs:choice>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/ph     task/cmd "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  <!-- Base type: itemgroup.class -->
  <xs:complexType name="info.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="itemgroup.class">
        <xs:choice minOccurs="0" maxOccurs="unbounded">
          <xs:group ref="itemgroup.cnt"/>
        </xs:choice>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/itemgroup     task/info "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  <!-- Base type: ol.class -->
  <xs:complexType name="substeps.class">
    <xs:complexContent>
      <xs:restriction base="ol.class">
        <xs:choice>
          <xs:element name="substep" type="substep.class" maxOccurs="unbounded"/>
        </xs:choice>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="univ-atts-importance-task"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/ol     task/substeps "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  <!-- Base type: li.class -->
  <xs:complexType name="substep.class">
    <xs:complexContent>
      <xs:restriction base="li.class">
        <xs:sequence>
          <xs:element name="cmd" type="cmd.class"/>
          <xs:choice minOccurs="0" maxOccurs="unbounded">
            <xs:element name="info" type="info.class"/>
            <xs:element name="tutorialinfo" type="tutorialinfo.class"/>
            <xs:element name="stepxmp" type="stepxmp.class"/>
          </xs:choice>
          <xs:element name="stepresult" type="stepresult.class" minOccurs="0"/>
        </xs:sequence>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/li     task/substep "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  <!-- Base type: itemgroup.class -->
  <xs:complexType name="tutorialinfo.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="itemgroup.class">
        <xs:choice minOccurs="0" maxOccurs="unbounded">
          <xs:group ref="itemgroup.cnt"/>
        </xs:choice>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/itemgroup task/tutorialinfo "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  <!-- Base type: itemgroup.class -->
  <xs:complexType name="stepxmp.class" mixed="true">
    <xs:complexContent mixed="true">
      <xs:restriction base="itemgroup.class">
        <xs:choice minOccurs="0" maxOccurs="unbounded">
          <xs:group ref="itemgroup.cnt"/>
        </xs:choice>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/itemgroup     task/tutorialinfo "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  <!-- Base type: ul.class -->
  <xs:complexType name="choices.class">
    <xs:complexContent>
      <xs:restriction base="ul.class">
        <xs:choice>
          <xs:element name="choice" type="choice.class" maxOccurs="unbounded"/>
        </xs:choice>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/ul     task/choices "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  <xs:complexType name="choice.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="li.class">
        <xs:sequence minOccurs="0" maxOccurs="unbounded">
          <xs:group ref="basic.ph"/>
        </xs:sequence>
        <xs:attributeGroup ref="global-atts"/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  <!-- Base type: itemgroup.class -->
  <xs:complexType name="stepresult.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="itemgroup.class">
        <xs:choice minOccurs="0" maxOccurs="unbounded">
          <xs:group ref="itemgroup.cnt"/>
        </xs:choice>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/itemgroup task/stepresult "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  <!-- Base type: section.class -->
  <xs:complexType name="result.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="section.class">
        <xs:choice minOccurs="0" maxOccurs="unbounded">
          <xs:group ref="section.notitle.cnt"/>
        </xs:choice>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/section     task/result "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  <!-- Base type: section.class -->
  <xs:complexType name="postreq.class" mixed="true">
    <xs:complexContent mixed="true">
      <xs:restriction base="section.class">
        <xs:choice minOccurs="0" maxOccurs="unbounded">
          <xs:group ref="section.notitle.cnt"/>
        </xs:choice>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/section task/postreq "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  <!-- Base type: sthead.class -->
  <xs:complexType name="choicetable.class">
    <xs:complexContent>
      <xs:restriction base="simpletable.class">
        <xs:sequence>
          <xs:element name="chhead" type="chhead.class" minOccurs="0"/>
          <xs:element name="chrow" type="chrow.class" maxOccurs="unbounded"/>
        </xs:sequence>
        <xs:attribute name="relcolwidth" type="xs:string"/>
        <xs:attribute name="keycol" type="xs:NMTOKEN" default="1"/>
        <xs:attribute name="refcols" type="xs:NMTOKENS"/>
        <xs:attributeGroup ref="display-atts"/>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attribute name="spectitle" type="xs:string"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/simpletable task/choicetable "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  <xs:complexType name="chhead.class">
    <xs:complexContent>
      <xs:restriction base="sthead.class">
        <xs:choice>
          <xs:element name="choptionhd" type="choptionhd.class"/>
          <xs:element name="chdeschd" type="chdeschd.class"/>
        </xs:choice>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/sthead task/chhead "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  <xs:complexType name="choptionhd.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="stentry.class">
        <xs:choice minOccurs="0" maxOccurs="unbounded">
          <xs:group ref="tblcell.cnt"/>
        </xs:choice>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attribute name="specentry" type="xs:string"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/stenrty task/choptionhd "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  <xs:complexType name="chdeschd.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="stentry.class">
        <xs:choice minOccurs="0" maxOccurs="unbounded">
          <xs:group ref="tblcell.cnt"/>
        </xs:choice>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attribute name="specentry" type="xs:string"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/stenrty task/chdeschd "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  <xs:complexType name="chrow.class">
    <xs:complexContent>
      <xs:restriction base="strow.class">
        <xs:choice>
          <xs:element name="choption" type="choption.class" minOccurs="0"/>
          <xs:element name="chdesc" type="chdesc.class" minOccurs="0"/>
        </xs:choice>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/strow "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  <xs:complexType name="choption.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="stentry.class">
        <xs:choice minOccurs="0" maxOccurs="unbounded">
          <xs:group ref="tblcell.cnt"/>
        </xs:choice>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attribute name="specentry" type="xs:string"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/stenrty task/choption "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
  <xs:complexType name="chdesc.class" mixed="true">
    <xs:complexContent>
      <xs:restriction base="stentry.class">
        <xs:choice minOccurs="0" maxOccurs="unbounded">
          <xs:group ref="tblcell.cnt"/>
        </xs:choice>
        <xs:attribute name="outputclass" type="xs:string"/>
        <xs:attribute name="specentry" type="xs:string"/>
        <xs:attributeGroup ref="univ-atts"/>
        <xs:attributeGroup ref="global-atts"/>
        <xs:attribute ref="class" default="- topic/stenrty task/chdesc "/>
      </xs:restriction>
    </xs:complexContent>
  </xs:complexType>
</xs:schema>
