<?xml version="1.0" encoding="UTF-8" ?>
<!-- topicmerge.xsl 
 | Merge DITA topics with "validation" of topic property
 |
 | (C) Copyright IBM Corporation 2001, 2002, 2003. All Rights Reserved.
 | This file is part of the DITA package on IBM's developerWorks site.
 | See license.txt for disclaimers.
 +
 | updates:
 *-->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- XML output) -->
<xsl:output method="xml"
            encoding="utf-8"
            indent="no"
            doctype-system="../dtd/ditabase.dtd"
            doctype-public="-//IBM//DTD DITA Composite//EN"
/>


<xsl:template match="*[contains(@class, ' map/map ')]">
  <xsl:processing-instruction name="xml-stylesheet">href="../xsl/ditaview_shell.xsl" type="text/xsl"</xsl:processing-instruction>
  <xsl:text>
  </xsl:text>
  <dita>
  <xsl:text>
  </xsl:text>
    <xsl:apply-templates/>
  <xsl:text>
  </xsl:text>
  </dita>
</xsl:template>

<xsl:template match="asterisk">
  <xsl:copy>
    <xsl:apply-templates select="@*" />
    <xsl:apply-templates />
  </xsl:copy>
</xsl:template>

<xsl:template match="@*">
  <xsl:copy-of select="." />
</xsl:template>

<xsl:template match="*[contains(@class, ' map/topicref ')]">
   <xsl:variable name="class" select="generate-id(@class)"/>
   <xsl:variable name="space" select="generate-id(@xml:space)"/>
<xsl:comment>Start of imbed for <xsl:value-of select="@href"/></xsl:comment>
<xsl:text>
</xsl:text>
  <xsl:choose>
	<xsl:when test="contains(@href,'#')">
		<!--processing an explicit topic reference-->
		<xsl:variable name="sourcefile">
			<xsl:value-of select="substring-before(@href,'#')"/>
		</xsl:variable>
		<xsl:variable name="sourcetopic">
			<xsl:value-of select="substring-after(@href,'#')"/>
		</xsl:variable>
             <xsl:message>Merging: <xsl:value-of select="$sourcefile"/>, nested topic id: <xsl:value-of select="$sourcetopic"/></xsl:message>

           <xsl:element name="{name(document($sourcefile,.)//*[@id=$sourcetopic][self::topic or contains(@class, ' topic/topic ')])}">
              <xsl:apply-templates select="document($sourcefile,.)//*[@id=$sourcetopic][self::topic or contains(@class, ' topic/topic ')]/@*"/>
              <xsl:copy-of select="document($sourcefile,.)//*[@id=$sourcetopic][self::topic or contains(@class, 'topic/topic ')]/*[contains(@class,' topic/prolog ') or contains(@class,' topic/title ') or contains(@class,' topic/body ')]"/>
	     <xsl:apply-templates/>
          </xsl:element>
	</xsl:when>
	<xsl:otherwise>
		<!--processing a file reference - take first topic-->
           <xsl:message>Merging: <xsl:value-of select="@href"/></xsl:message>
           <xsl:element name="{name(document(@href,.)/descendant::*[self::topic or contains(@class, ' topic/topic ')][position()=1])}">
              <xsl:apply-templates select="document(@href,.)/descendant::*[self::topic or contains(@class, ' topic/topic ')][position()=1]/@*" />

              <xsl:copy-of select="document(@href,.)/descendant::*[self::topic or contains(@class, ' topic/topic ')][position()=1]/*[contains(@class,' topic/prolog ') or contains(@class,' topic/title ') or contains(@class,' topic/body ')]"/>
	     <xsl:apply-templates/>
          </xsl:element>
	</xsl:otherwise>
  </xsl:choose>
<xsl:text>
</xsl:text>
  <xsl:comment>End of imbed for <xsl:value-of select="@href"/></xsl:comment>
<xsl:text>
</xsl:text>
  <!--xsl:apply-templates/-->
</xsl:template>

</xsl:stylesheet>